Failed to connect to virtio-serial channel

Bug #1243190 reported by Nikos Skalkotos on 2013-10-22
54
This bug affects 13 people
Affects Status Importance Assigned to Milestone
libguestfs (Ubuntu)
Undecided
Unassigned
Saucy
Undecided
Unassigned

Bug Description

Description: Ubuntu 13.10
Release: 13.10

In a clean system if I do:

sudo apt-get install libguestfs-tools

a guestfs appliance is created in the post-install script that does not work.

If I do:

sudo libguestfs-test-tool

I get the following error:

Failed to connect to virtio-serial channel.

This is a fatal error and the appliance will now exit.

Usually this error is caused by either QEMU or the appliance
kernel not supporting the vmchannel method that the
libguestfs library chose to use. Please run
'libguestfs-test-tool' and provide the complete, unedited
output to the libguestfs developers, either in a bug report
or on the libguestfs redhat com mailing list.

Please find attached the complete output of the libguestfs-test-tool command execution

SRU INFORMATION:
----------------
TEST CASE: see above in original bug description
FIX: https://github.com/libguestfs/libguestfs/commit/ec6f9ee5
REGRESSION POTENTIAL: None, the udev init script in the saucy version is completely broken.

Nikos Skalkotos (skalkoto) wrote :
Richard Jones (rjones-redhat) wrote :

Which version of libguestfs is this?

I'm fairly sure that you want this patch:
https://github.com/libguestfs/libguestfs/commit/ec6f9ee542e0e9ad0109a7522e83ea07b2f8a002

Richard Jones (rjones-redhat) wrote :

OK, 1.22.4. I'm fairly sure that's the patch that would fix this.

Also note that 1.22.4 is vulnerable to at least one, possibly two CVEs. Would advise updating to 1.22.7, and ideally to 1.24.

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in libguestfs (Ubuntu):
status: New → Confirmed

I can confirm that the https://github.com/libguestfs/libguestfs/commit/ec6f9ee542e0e9ad0109a7522e83ea07b2f8a002 patch solves this issue.

I did the following to test:

sudo apt-get source libguestfs
sudo apt-get build-dep libguestfs
wget https://github.com/libguestfs/libguestfs/commit/ec6f9ee542e0e9ad0109a7522e83ea07b2f8a002.patch
cd libguestfs-1.22.4/
patch -p1< ../ec6f9ee542e0e9ad0109a7522e83ea07b2f8a002.patch
dpkg-source --commit
<name the patch and save it>
dpkg-buildpackage -rfakeroot

dpkg-builpackage fails on my machine for some reason, but not before it has created the new supermin images. So I copy the new images:

sudo cp debian/build-default/appliance/supermin.d/*.img /usr/lib/guestfs/supermin.d/

and then libguestfs-test-tool works again.

Martin Pitt (pitti) on 2013-10-30
Changed in libguestfs (Ubuntu):
status: Confirmed → Triaged
summary: - Broken libguestfs package in sauce
+ Broken libguestfs package in saucy
summary: - Broken libguestfs package in saucy
+ Failed to connect to virtio-serial channel
Martin Pitt (pitti) wrote :

This is fixed in the latest upstream release, syncing from Debian.

Changed in libguestfs (Ubuntu):
status: Triaged → Fix Released
Martin Pitt (pitti) wrote :

This bug was fixed in the package libguestfs - 1:1.23.33-1

---------------
libguestfs (1:1.23.33-1) experimental; urgency=low

  * New upstream development version
  * Added patch to fix out-of-tree build
  * Updated (build-)dependencies
  * Integrated guestfish into libguestfs-tools package (Closes: #721938)
  * Added option to generate Java 6 compatible bytecode
  * Detect Ruby 2 if available
  * Automatically detect available Lua versions
  * Install shared object for Ruby bindings from multiarch directory
  * Updated Javadoc install path
  * Updated install rule for supermin image components
  * Updated symbols file

 -- Hilko Bengen <email address hidden> Wed, 16 Oct 2013 22:43:50 +0200

libguestfs (1:1.23.7-1) experimental; urgency=low

  * New upstream development version

 -- Hilko Bengen <email address hidden> Sat, 06 Jul 2013 10:52:43 +0200

libguestfs (1:1.23.6-1) experimental; urgency=low

  * New upstream development version
  * Rebased patch queue
  * Since 1.23.5, Augeas >= 1.0.0 is required.
  * Added symbols file for libguestfs0

 -- Hilko Bengen <email address hidden> Sun, 30 Jun 2013 17:14:08 +0200

* Martin Pitt:

> This is fixed in the latest upstream release, syncing from Debian.

libguestfs 1:1.23.33-1 is

- marked as a development version by upstream.
- placed in Debian's experimental repository.

The latest release in Debian/unstable is 1:1.22.7-1. If you have any
expectations wrt the package being tested, you should use that.

Cheers,
-Hilko

Richard Jones (rjones-redhat) wrote :

BTW 1.22.7 upstream doesn't contain commit ec6f9ee542e0e9ad0109a7522e83ea07b2f8a002
which is the fix for this bug, unless it has been added separately in
the Debian package.

I'd prefer everyone switched to 1.24 :-)

I'm also worried that 1.23.33 may not contain a fix for CVE-2013-4419
http://libguestfs.org/guestfs.3.html#cve-2013-4419
(Upstream 1.23.33 certainly doesn't, but you may have added it as a patch).

Martin Pitt (pitti) wrote :

Indeed, let's move to 1.24.0, that's a stable release again with the security fix.

Hilko Bengen (bengen) wrote :

* Martin Pitt:

> Indeed, let's move to 1.24.0, that's a stable release again with the
> security fix.

If you can wait a few days, that's what I'm going to do for
Debian/unstable anyhow.

-Hilko

Martin Pitt (pitti) wrote :

Ah, sorry Hilko, already uploaded: https://launchpad.net/ubuntu/+source/libguestfs/1:1.24.0-0ubuntu1 (I felt guilty of introducing a CVE). But I'll sync the Debian unstable version once it lands, thanks!

Matt Whiteley (mwhiteley) wrote :

Is this something that will be published to saucy-updates or saucy-backports?

Nikos Skalkotos (skalkoto) wrote :

Are you planning to release an update for saucy or will the release stay with an unusable package?

Matt Whiteley (mwhiteley) wrote :

Could we please get a decision on if this will be updated in Saucy or if I should file a backports request for it?

Thanks!

Martin Pitt (pitti) wrote :

I'll prepare an SRU, if you can test it.

Martin Pitt (pitti) on 2013-11-19
Changed in libguestfs (Ubuntu Saucy):
status: New → In Progress
description: updated
Martin Pitt (pitti) wrote :

SRU uploaded, waiting in the SRU review queue now (https://launchpad.net/ubuntu/saucy/+queue?queue_state=1).

teto (teto) wrote :

Hi, I dunno how SRU works, I've tested the SRU code (untared tarball, then compiled and launched tests) on a recent saucy installation (on top of a raring install and had many tests failing 'cos of tests not being executable. I am not sureif that's because permissions should be set by the .deb. Also autogen.sh and ./configure were not executable

FAIL: test-wcrtomb-w32-5.sh
PASS: test-wctype-h
PASS: test-write
/bin/bash: line 9: ./test-xalloc-die.sh: Permission denied
FAIL: test-xalloc-die.sh
/bin/bash: line 9: ./test-xstrtol.sh: Permission denied
FAIL: test-xstrtol.sh
/bin/bash: line 9: ./test-xstrtoll.sh: Permission denied
FAIL: test-xstrtoll.sh
/bin/bash: line 9: ./test-xstrtoumax.sh: Permission denied
FAIL: test-xstrtoumax.sh
PASS: test-xvasprintf
======================
48 of 184 tests failed
======================

Richard Jones (rjones-redhat) wrote :

This doesn't look happy. If configure and/or autogen.sh are not executable, it seems to indicate that permissions got badly screwed up somewhere along the way :-( Also the *.sh scripts mentioned in comment 18 ought to be executable. If they're not, it would explain why the tests completely fail like that.

Matt Whiteley (mwhiteley) wrote :

Martin - thanks!

I had the udev package held to 175-0ubuntu29 and allowed it to update to the released 204-0ubuntu19 version. I then built the 1.22.4-1ubuntu1 package locally using pbuilder and it works great. Both libguestfs-test-tool and my application using libguestfs work properly.

Martin Pitt (pitti) wrote :

Hello Matt,

Matt Whiteley [2013-11-19 19:38 -0000]:
> I had the udev package held to 175-0ubuntu29 and allowed it to update to
> the released 204-0ubuntu19 version. I then built the 1.22.4-1ubuntu1
> package locally using pbuilder and it works great. Both libguestfs-test-
> tool and my application using libguestfs work properly.

Thanks! I'm afraid the package will need to be re-tested after it gets
accepted into -proposed, so that the test will happen with the
actual "officially" compiled .debs, but as the change only concerns
scripts this is already a great data point.

Matt Whiteley (mwhiteley) wrote :

Great, happy to test again if you need it.

Hello Nikos, or anyone else affected,

Accepted libguestfs into saucy-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/libguestfs/1:1.22.4-1ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in libguestfs (Ubuntu Saucy):
status: In Progress → Fix Committed
tags: added: verification-needed

Hello Brian,

I've installed the fix available from saucy-proposed repository on my up-to-date saucy system and I can confirm that it fixes this bug.

Here are the details of steps I performed to verify the fix:

1. Install updates for guestfish and libguestfs-tools packages from saucy-proposed (1:1.22.4-1ubuntu1 version). You may find complete output of "aptitude -t saucy-proposed install guestfish libguestfs-tools" command in the attachment (aptitude-install-fix-from-saucy-proposed-output.txt).

2. Run libguestfs-test-tool and check its output. Now it finally works fine again and at the end out its output it prints "TEST FINISHED OK". Full output of this command is in the attachment (libguestfs-test-tool-output.txt).

tags: added: verification-done
removed: verification-needed
Richard Jones (rjones-redhat) wrote :

The libguestfs-test-tool output (comment 25) looks fine to me.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libguestfs - 1:1.22.4-1ubuntu1

---------------
libguestfs (1:1.22.4-1ubuntu1) saucy-proposed; urgency=low

  * Add debian/patches/0000-Fix-udev-startup.patch: Fix udevd startup in
    appliances. Patch backported from upstream git. (LP: #1243190)
 -- Martin Pitt <email address hidden> Tue, 19 Nov 2013 07:36:58 +0100

Changed in libguestfs (Ubuntu Saucy):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for libguestfs has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers